datablock AudioProfile(bananaGunEquipSound)
{
   filename    = "./sounds/laughequip.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(bananaGunShootSound)
{
   filename    = "./sounds/pewpew.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(bananaSplat1Sound)
{
   filename    = "./sounds/splat1.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bananaSplat2Sound)
{
   filename    = "./sounds/splat2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bananaSplat3Sound)
{
   filename    = "./sounds/splat3.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bananaSplat4Sound)
{
   filename    = "./sounds/splat4.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(bananaSplat5Sound)
{
   filename    = "./sounds/splat5.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(bananaGunExplosionParticle)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS  = 600;
   lifetimeVarianceMS   = 50;
   textureName = "base/data/particles/cloud";
   colors[1] = "1 1 0 1";
   colors[2] = "1 0.9 0 1";
   colors[3] = "0 0 0 0.6";
   sizes[1] = 0.5;
   sizes[2] = 0.6;
   sizes[3] = 0.4;
   times[1] = 0;
   times[2] = 0.3;
   times[3] = 0.5;
};

datablock ParticleEmitterData(bananaGunExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 2;
   ejectionVelocity = 1;
   velocityVariance = 0.4;
   ejectionOffset = 0.5;
   thetaMin = 0;
   thetaMax = 180;
   phiReferenceVel   = 0;
   phiVariance = 360;
   overrideAdvance = false;
   particles = "bananaGunExplosionParticle";
};

datablock ExplosionData(bananaGunExplosion)
{
   //explosionShape = "";
	soundProfile = ""; //We use our own sounds

   lifeTimeMS = 220;

   particleEmitter = bananaGunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = bananaGunExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 2;
   lightStartColor = "0.5 0.8 0.9";
   lightEndColor = "0 0 0";
};


AddDamageType("Banana",   '<bitmap:add-ons/Weapon_BananaRifle/bananaci> %1',    '%2 <bitmap:add-ons/Weapon_BananaRifle/bananaci> %1',0.2,1);
datablock ProjectileData(bananaProjectile)
{
   projectileShapeName = "./banana/BanAna.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::Banana;
   radiusDamageType    = $DamageType::Banana;

   // Bananas aren't that strong... are they?
   brickExplosionRadius = 0;
   brickExplosionImpact = false;
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = bananaGunExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 1;

   hasLight    = true;
   lightRadius = 2.0;
   lightColor  = "1 1 0";

   uiName = "Banana";
};

// Don't look in the bananagun folder..... there's tons of materials..
datablock ItemData(bananaGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./bananagun/AKBananamag.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Banana Rifle";
	iconName = "./Icon_BananaRifle";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";

	image = bananaGunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(bananaGunImage)
{
   shapeFile = "./bananagun/AKBananamag.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = bananaGunItem;
   ammo = " ";
   projectile = bananaProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.25 0.25 0.25 1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.4;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= bananaGunEquipSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= bananaGunShootSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
   stateTransitionOnTriggerDown[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function bananaProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
   Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
   // Basically randomize the sound from 1 to 5 from what we have created at the first part of the script
   serverPlay3D("bananaSplat" @ getRandom(1, 5) @ "Sound", %pos);
}